Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 74500)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 74501)
@@ -97,5 +97,5 @@
                 /* Create Desktop pane: */
                 m_pPaneDesktop = new UIWelcomePane;
-                AssertPtrReturnVoid(m_pPaneDesktop);
+                if (m_pPaneDesktop)
                 {
                     /* Configure pane: */
@@ -183,47 +183,50 @@
 {
     /* Update desktop pane: */
-    AssertPtrReturnVoid(m_pPaneDesktop);
-    m_pPaneDesktop->updateDetailsError(strError);
+    if (m_pPaneDesktop)
+        m_pPaneDesktop->updateDetailsError(strError);
 }
 
 void UIToolPaneGlobal::retranslateUi()
 {
-    /* Translate Global Tools welcome screen: */
-    m_pPaneDesktop->setToolsPaneIcon(UIIconPool::iconSet(":/tools_banner_global_200px.png"));
-    m_pPaneDesktop->setToolsPaneText(
-        tr("<h3>Welcome to VirtualBox!</h3>"
-           "<p>This window represents a set of global tools "
-           "which are currently opened (or can be opened). "
-           "They are not related to any particular machine but "
-           "to the complete VM collection. For a list of currently "
-           "available tools check the corresponding menu at the right "
-           "side of the main tool bar located at the top of the window. "
-           "This list will be extended with new tools in future releases.</p>"
-           "<p>You can press the <b>%1</b> key to get instant help, or visit "
-           "<a href=https://www.virtualbox.org>www.virtualbox.org</a> "
-           "for more information and latest news.</p>")
-           .arg(QKeySequence(QKeySequence::HelpContents).toString(QKeySequence::NativeText)));
-
-    /* Wipe out the tool descriptions: */
-    m_pPaneDesktop->removeToolDescriptions();
-
-    /* Add tool descriptions: */
-    QAction *pAction1 = m_pActionPool->action(UIActionIndexST_M_Tools_M_Global_S_VirtualMediaManager);
-    m_pPaneDesktop->addToolDescription(pAction1,
-                                       tr("Tool to observe virtual storage media. "
-                                          "Reflects all the chains of virtual disks you have registered "
-                                          "(per each storage type) within your virtual machines and allows for media "
-                                          "operations like copy, remove, release "
-                                          "(detach it from VMs where it is currently attached to) and observe their properties. "
-                                          "Allows to edit medium attributes like type, "
-                                          "location/name, description and size (for dynamical storages "
-                                          "only)."));
-    QAction *pAction2 = m_pActionPool->action(UIActionIndexST_M_Tools_M_Global_S_HostNetworkManager);
-    m_pPaneDesktop->addToolDescription(pAction2,
-                                       tr("Tool to control host-only network interfaces. "
-                                          "Reflects host-only networks, their DHCP servers and allows "
-                                          "for operations on the networks like possibility to create, remove "
-                                          "and observe their properties. Allows to edit various "
-                                          "attributes for host-only interface and corresponding DHCP server."));
+    if (m_pPaneDesktop)
+    {
+        /* Translate Global Tools welcome screen: */
+        m_pPaneDesktop->setToolsPaneIcon(UIIconPool::iconSet(":/tools_banner_global_200px.png"));
+        m_pPaneDesktop->setToolsPaneText(
+            tr("<h3>Welcome to VirtualBox!</h3>"
+               "<p>This window represents a set of global tools "
+               "which are currently opened (or can be opened). "
+               "They are not related to any particular machine but "
+               "to the complete VM collection. For a list of currently "
+               "available tools check the corresponding menu at the right "
+               "side of the main tool bar located at the top of the window. "
+               "This list will be extended with new tools in future releases.</p>"
+               "<p>You can press the <b>%1</b> key to get instant help, or visit "
+               "<a href=https://www.virtualbox.org>www.virtualbox.org</a> "
+               "for more information and latest news.</p>")
+               .arg(QKeySequence(QKeySequence::HelpContents).toString(QKeySequence::NativeText)));
+
+        /* Wipe out the tool descriptions: */
+        m_pPaneDesktop->removeToolDescriptions();
+
+        /* Add tool descriptions: */
+        QAction *pAction1 = m_pActionPool->action(UIActionIndexST_M_Tools_M_Global_S_VirtualMediaManager);
+        m_pPaneDesktop->addToolDescription(pAction1,
+                                           tr("Tool to observe virtual storage media. "
+                                              "Reflects all the chains of virtual disks you have registered "
+                                              "(per each storage type) within your virtual machines and allows for media "
+                                              "operations like copy, remove, release "
+                                              "(detach it from VMs where it is currently attached to) and observe their properties. "
+                                              "Allows to edit medium attributes like type, "
+                                              "location/name, description and size (for dynamical storages "
+                                              "only)."));
+        QAction *pAction2 = m_pActionPool->action(UIActionIndexST_M_Tools_M_Global_S_HostNetworkManager);
+        m_pPaneDesktop->addToolDescription(pAction2,
+                                           tr("Tool to control host-only network interfaces. "
+                                              "Reflects host-only networks, their DHCP servers and allows "
+                                              "for operations on the networks like possibility to create, remove "
+                                              "and observe their properties. Allows to edit various "
+                                              "attributes for host-only interface and corresponding DHCP server."));
+    }
 }
 
@@ -234,5 +237,5 @@
 
     /* Create desktop pane: */
-    openTool(ToolTypeGlobal_Desktop);
+    openTool(ToolTypeGlobal_VirtualMedia);
 
     /* Apply language settings: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp	(revision 74500)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneMachine.cpp	(revision 74501)
@@ -101,5 +101,5 @@
                 /* Create Desktop pane: */
                 m_pPaneDesktop = new UIWelcomePane(m_pActionPool->action(UIActionIndexST_M_Group_S_Refresh));
-                AssertPtrReturnVoid(m_pPaneDesktop);
+                if (m_pPaneDesktop)
                 {
                     /* Configure pane: */
@@ -207,6 +207,6 @@
 {
     /* Update desktop pane: */
-    AssertPtrReturnVoid(m_pPaneDesktop);
-    m_pPaneDesktop->updateDetailsError(strError);
+    if (m_pPaneDesktop)
+        m_pPaneDesktop->updateDetailsError(strError);
 }
 
@@ -255,62 +255,65 @@
 void UIToolPaneMachine::retranslateUi()
 {
-    /* Translate Machine Tools welcome screen: */
-    if (!m_pItem || !m_pItem->accessible())
-    {
-        m_pPaneDesktop->setToolsPaneIcon(UIIconPool::iconSet(":/welcome_200px.png"));
-        m_pPaneDesktop->setToolsPaneText(
-            tr("<h3>Welcome to VirtualBox!</h3>"
-               "<p>The left part of this window lists all virtual "
-               "machines and virtual machine groups on your computer. "
-               "The list is empty now because you haven't created any "
-               "virtual machines yet.</p>"
-               "<p>In order to create a new virtual machine, press the "
-               "<b>New</b> button in the main tool bar located at the "
-               "top of the window.</p>"
-               "<p>You can press the <b>%1</b> key to get instant help, or visit "
-               "<a href=https://www.virtualbox.org>www.virtualbox.org</a> "
-               "for more information and latest news.</p>")
-               .arg(QKeySequence(QKeySequence::HelpContents).toString(QKeySequence::NativeText)));
-    }
-    else
-    {
-        m_pPaneDesktop->setToolsPaneIcon(UIIconPool::iconSet(":/tools_banner_machine_200px.png"));
-        m_pPaneDesktop->setToolsPaneText(
-            tr("<h3>Welcome to VirtualBox!</h3>"
-               "<p>The left part of this window lists all virtual "
-               "machines and virtual machine groups on your computer.</p>"
-               "<p>The right part of this window represents a set of "
-               "tools which are currently opened (or can be opened) for "
-               "the currently chosen machine. For a list of currently "
-               "available tools check the corresponding menu at the right "
-               "side of the main tool bar located at the top of the window. "
-               "This list will be extended with new tools in future releases.</p>"
-               "<p>You can press the <b>%1</b> key to get instant help, or visit "
-               "<a href=https://www.virtualbox.org>www.virtualbox.org</a> "
-               "for more information and latest news.</p>")
-               .arg(QKeySequence(QKeySequence::HelpContents).toString(QKeySequence::NativeText)));
-    }
-
-    /* Wipe out the tool descriptions: */
-    m_pPaneDesktop->removeToolDescriptions();
-
-    /* Add tool descriptions: */
-    if (m_pItem && m_pItem->accessible())
-    {
-        QAction *pAction1 = m_pActionPool->action(UIActionIndexST_M_Tools_M_Machine_S_Details);
-        m_pPaneDesktop->addToolDescription(pAction1,
-                                           tr("Tool to observe virtual machine (VM) details. "
-                                              "Reflects groups of properties for the currently chosen VM and allows "
-                                              "basic operations on certain properties (like the machine storage devices)."));
-        QAction *pAction2 = m_pActionPool->action(UIActionIndexST_M_Tools_M_Machine_S_Snapshots);
-        m_pPaneDesktop->addToolDescription(pAction2,
-                                           tr("Tool to control virtual machine (VM) snapshots. "
-                                              "Reflects snapshots created for the currently selected VM and allows "
-                                              "snapshot operations like create, remove, "
-                                              "restore (make current) and observe their properties. Allows to "
-                                              "edit snapshot attributes like name and description."));
-        QAction *pAction3 = m_pActionPool->action(UIActionIndexST_M_Tools_M_Machine_S_LogViewer);
-        m_pPaneDesktop->addToolDescription(pAction3,
-                                           tr("Tool to display  virtual machine (VM) logs. "));
+    if (m_pPaneDesktop)
+    {
+        /* Translate Machine Tools welcome screen: */
+        if (!m_pItem || !m_pItem->accessible())
+        {
+            m_pPaneDesktop->setToolsPaneIcon(UIIconPool::iconSet(":/welcome_200px.png"));
+            m_pPaneDesktop->setToolsPaneText(
+                tr("<h3>Welcome to VirtualBox!</h3>"
+                   "<p>The left part of this window lists all virtual "
+                   "machines and virtual machine groups on your computer. "
+                   "The list is empty now because you haven't created any "
+                   "virtual machines yet.</p>"
+                   "<p>In order to create a new virtual machine, press the "
+                   "<b>New</b> button in the main tool bar located at the "
+                   "top of the window.</p>"
+                   "<p>You can press the <b>%1</b> key to get instant help, or visit "
+                   "<a href=https://www.virtualbox.org>www.virtualbox.org</a> "
+                   "for more information and latest news.</p>")
+                   .arg(QKeySequence(QKeySequence::HelpContents).toString(QKeySequence::NativeText)));
+        }
+        else
+        {
+            m_pPaneDesktop->setToolsPaneIcon(UIIconPool::iconSet(":/tools_banner_machine_200px.png"));
+            m_pPaneDesktop->setToolsPaneText(
+                tr("<h3>Welcome to VirtualBox!</h3>"
+                   "<p>The left part of this window lists all virtual "
+                   "machines and virtual machine groups on your computer.</p>"
+                   "<p>The right part of this window represents a set of "
+                   "tools which are currently opened (or can be opened) for "
+                   "the currently chosen machine. For a list of currently "
+                   "available tools check the corresponding menu at the right "
+                   "side of the main tool bar located at the top of the window. "
+                   "This list will be extended with new tools in future releases.</p>"
+                   "<p>You can press the <b>%1</b> key to get instant help, or visit "
+                   "<a href=https://www.virtualbox.org>www.virtualbox.org</a> "
+                   "for more information and latest news.</p>")
+                   .arg(QKeySequence(QKeySequence::HelpContents).toString(QKeySequence::NativeText)));
+        }
+
+        /* Wipe out the tool descriptions: */
+        m_pPaneDesktop->removeToolDescriptions();
+
+        /* Add tool descriptions: */
+        if (m_pItem && m_pItem->accessible())
+        {
+            QAction *pAction1 = m_pActionPool->action(UIActionIndexST_M_Tools_M_Machine_S_Details);
+            m_pPaneDesktop->addToolDescription(pAction1,
+                                               tr("Tool to observe virtual machine (VM) details. "
+                                                  "Reflects groups of properties for the currently chosen VM and allows "
+                                                  "basic operations on certain properties (like the machine storage devices)."));
+            QAction *pAction2 = m_pActionPool->action(UIActionIndexST_M_Tools_M_Machine_S_Snapshots);
+            m_pPaneDesktop->addToolDescription(pAction2,
+                                               tr("Tool to control virtual machine (VM) snapshots. "
+                                                  "Reflects snapshots created for the currently selected VM and allows "
+                                                  "snapshot operations like create, remove, "
+                                                  "restore (make current) and observe their properties. Allows to "
+                                                  "edit snapshot attributes like name and description."));
+            QAction *pAction3 = m_pActionPool->action(UIActionIndexST_M_Tools_M_Machine_S_LogViewer);
+            m_pPaneDesktop->addToolDescription(pAction3,
+                                               tr("Tool to display  virtual machine (VM) logs. "));
+        }
     }
 }
@@ -322,5 +325,5 @@
 
     /* Create desktop pane: */
-    openTool(ToolTypeMachine_Desktop);
+    openTool(ToolTypeMachine_Details);
 
     /* Apply language settings: */