Index: trunk/src/VBox/GuestHost/DragAndDrop/DnDDroppedFiles.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/DnDDroppedFiles.cpp	(revision 74208)
+++ trunk/src/VBox/GuestHost/DragAndDrop/DnDDroppedFiles.cpp	(revision 74526)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2014-2017 Oracle Corporation
+ * Copyright (C) 2014-2018 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -38,5 +38,5 @@
     , m_hDir(NULL) { }
 
-DnDDroppedFiles::DnDDroppedFiles(const char *pszPath, uint32_t fFlags)
+DnDDroppedFiles::DnDDroppedFiles(const char *pszPath, DNDURIDROPPEDFILEFLAGS fFlags /* = DNDURIDROPPEDFILE_FLAGS_NONE */)
     : m_fOpen(0)
     , m_hDir(NULL)
@@ -101,5 +101,5 @@
 }
 
-int DnDDroppedFiles::OpenEx(const char *pszPath, uint32_t fFlags)
+int DnDDroppedFiles::OpenEx(const char *pszPath, DNDURIDROPPEDFILEFLAGS fFlags /* = DNDURIDROPPEDFILE_FLAGS_NONE */)
 {
     AssertPtrReturn(pszPath, VERR_INVALID_POINTER);
@@ -168,5 +168,5 @@
 }
 
-int DnDDroppedFiles::OpenTemp(uint32_t fFlags)
+int DnDDroppedFiles::OpenTemp(DNDURIDROPPEDFILEFLAGS fFlags /* = DNDURIDROPPEDFILE_FLAGS_NONE */)
 {
     AssertReturn(fFlags == 0, VERR_INVALID_PARAMETER); /* Flags not supported yet. */
Index: trunk/src/VBox/GuestHost/DragAndDrop/DnDURIList.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/DnDURIList.cpp	(revision 74208)
+++ trunk/src/VBox/GuestHost/DragAndDrop/DnDURIList.cpp	(revision 74526)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2014-2017 Oracle Corporation
+ * Copyright (C) 2014-2018 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -48,5 +48,5 @@
 }
 
-int DnDURIList::addEntry(const char *pcszSource, const char *pcszTarget, uint32_t fFlags)
+int DnDURIList::addEntry(const char *pcszSource, const char *pcszTarget, DNDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pcszSource, VERR_INVALID_POINTER);
@@ -64,5 +64,5 @@
                          pcszSource, pcszTarget, (uint64_t)objInfo.cbObject, objInfo.Attr.fMode));
 
-            DnDURIObject *pObjFile = new DnDURIObject(DnDURIObject::File, pcszSource, pcszTarget);
+            DnDURIObject *pObjFile = new DnDURIObject(DnDURIObject::Type_File, pcszSource, pcszTarget);
             if (pObjFile)
             {
@@ -70,5 +70,5 @@
                 {
                     /** @todo Add a standard fOpen mode for this list. */
-                    rc = pObjFile->Open(DnDURIObject::Source, RTFILE_O_OPEN | RTFILE_O_READ | RTFILE_O_DENY_WRITE, objInfo.Attr.fMode);
+                    rc = pObjFile->Open(DnDURIObject::View_Source, RTFILE_O_OPEN | RTFILE_O_READ | RTFILE_O_DENY_WRITE, objInfo.Attr.fMode);
                 }
 
@@ -90,5 +90,5 @@
             LogFlowFunc(("Directory '%s' -> '%s' (file mode 0x%x)\n", pcszSource, pcszTarget, objInfo.Attr.fMode));
 
-            DnDURIObject *pObjDir = new DnDURIObject(DnDURIObject::Directory, pcszSource, pcszTarget,
+            DnDURIObject *pObjDir = new DnDURIObject(DnDURIObject::Type_Directory, pcszSource, pcszTarget,
                                                      objInfo.Attr.fMode, 0 /* Size */);
             if (pObjDir)
@@ -112,5 +112,6 @@
 
 int DnDURIList::appendPathRecursive(const char *pcszSrcPath,
-                                    const char *pcszDstPath, const char *pcszDstBase, size_t cchDstBase, uint32_t fFlags)
+                                    const char *pcszDstPath, const char *pcszDstBase, size_t cchDstBase,
+                                    DNDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pcszSrcPath, VERR_INVALID_POINTER);
@@ -118,6 +119,6 @@
     AssertPtrReturn(pcszDstPath, VERR_INVALID_POINTER);
 
-    LogFlowFunc(("pcszSrcPath=%s, pcszDstPath=%s, pcszDstBase=%s, cchDstBase=%zu\n",
-                 pcszSrcPath, pcszDstPath, pcszDstBase, cchDstBase));
+    LogFlowFunc(("pcszSrcPath=%s, pcszDstPath=%s, pcszDstBase=%s, cchDstBase=%zu, fFlags=0x%x\n",
+                 pcszSrcPath, pcszDstPath, pcszDstBase, cchDstBase, fFlags));
 
     RTFSOBJINFO objInfo;
@@ -278,5 +279,5 @@
 }
 
-int DnDURIList::AppendNativePath(const char *pszPath, uint32_t fFlags)
+int DnDURIList::AppendNativePath(const char *pszPath, DNDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pszPath, VERR_INVALID_POINTER);
@@ -307,5 +308,5 @@
 
 int DnDURIList::AppendNativePathsFromList(const char *pszNativePaths, size_t cbNativePaths,
-                                          uint32_t fFlags)
+                                          DNDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pszNativePaths, VERR_INVALID_POINTER);
@@ -318,5 +319,5 @@
 
 int DnDURIList::AppendNativePathsFromList(const RTCList<RTCString> &lstNativePaths,
-                                          uint32_t fFlags)
+                                          DNDURILISTFLAGS fFlags)
 {
     int rc = VINF_SUCCESS;
@@ -334,5 +335,5 @@
 }
 
-int DnDURIList::AppendURIPath(const char *pszURI, uint32_t fFlags)
+int DnDURIList::AppendURIPath(const char *pszURI, DNDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pszURI, VERR_INVALID_POINTER);
@@ -385,5 +386,5 @@
 
 int DnDURIList::AppendURIPathsFromList(const char *pszURIPaths, size_t cbURIPaths,
-                                       uint32_t fFlags)
+                                       DNDURILISTFLAGS fFlags)
 {
     AssertPtrReturn(pszURIPaths, VERR_INVALID_POINTER);
@@ -396,5 +397,5 @@
 
 int DnDURIList::AppendURIPathsFromList(const RTCList<RTCString> &lstURI,
-                                       uint32_t fFlags)
+                                       DNDURILISTFLAGS fFlags)
 {
     int rc = VINF_SUCCESS;
@@ -447,5 +448,5 @@
 }
 
-int DnDURIList::RootFromURIData(const void *pvData, size_t cbData, uint32_t fFlags)
+int DnDURIList::SetFromURIData(const void *pvData, size_t cbData, DNDURILISTFLAGS fFlags)
 {
     Assert(fFlags == 0); RT_NOREF1(fFlags);
@@ -493,5 +494,5 @@
 }
 
-RTCString DnDURIList::RootToString(const RTCString &strPathBase /* = "" */,
+RTCString DnDURIList::GetRootEntries(const RTCString &strPathBase /* = "" */,
                                    const RTCString &strSeparator /* = "\r\n" */) const
 {
Index: trunk/src/VBox/GuestHost/DragAndDrop/DnDURIObject.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/DnDURIObject.cpp	(revision 74208)
+++ trunk/src/VBox/GuestHost/DragAndDrop/DnDURIObject.cpp	(revision 74526)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2014-2017 Oracle Corporation
+ * Copyright (C) 2014-2018 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -37,5 +37,5 @@
 
 DnDURIObject::DnDURIObject(void)
-    : m_Type(Unknown)
+    : m_Type(Type_Unknown)
     , m_fOpen(false)
     , m_fMode(0)
@@ -46,9 +46,9 @@
 }
 
-DnDURIObject::DnDURIObject(Type type,
+DnDURIObject::DnDURIObject(Type enmType,
                            const RTCString &strSrcPath /* = 0 */,
                            const RTCString &strDstPath /* = 0 */,
                            uint32_t fMode  /* = 0 */, uint64_t cbSize  /* = 0 */)
-    : m_Type(type)
+    : m_Type(enmType)
     , m_strSrcPath(strSrcPath)
     , m_strTgtPath(strDstPath)
@@ -74,5 +74,5 @@
     switch (m_Type)
     {
-        case File:
+        case Type_File:
         {
             RTFileClose(u.m_hFile);
@@ -81,5 +81,5 @@
         }
 
-        case Directory:
+        case Type_Directory:
             break;
 
@@ -102,10 +102,10 @@
     switch (m_Type)
     {
-        case File:
+        case Type_File:
             Assert(m_cbProcessed <= m_cbSize);
             fComplete = m_cbProcessed == m_cbSize;
             break;
 
-        case Directory:
+        case Type_Directory:
             fComplete = true;
             break;
@@ -124,24 +124,24 @@
 }
 
-int DnDURIObject::Open(Dest enmDest, uint64_t fOpen /* = 0 */, uint32_t fMode /* = 0 */)
-{
-    return OpenEx(  enmDest == Source
+int DnDURIObject::Open(View enmView, uint64_t fOpen /* = 0 */, uint32_t fMode /* = 0 */)
+{
+    return OpenEx(  enmView == View_Source
                   ? m_strSrcPath : m_strTgtPath
-                  , m_Type, enmDest, fOpen, fMode, 0 /* fFlags */);
-}
-
-int DnDURIObject::OpenEx(const RTCString &strPath, Type enmType, Dest enmDest,
-                         uint64_t fOpen /* = 0 */, uint32_t fMode /* = 0 */, uint32_t fFlags /* = 0 */)
+                  , m_Type, enmView, fOpen, fMode, 0 /* fFlags */);
+}
+
+int DnDURIObject::OpenEx(const RTCString &strPath, Type enmType, View enmView,
+                         uint64_t fOpen /* = 0 */, uint32_t fMode /* = 0 */, DNDURIOBJECTFLAGS fFlags /* = DNDURIOBJECT_FLAGS_NONE */)
 {
     Assert(fFlags == 0); RT_NOREF1(fFlags);
     int rc = VINF_SUCCESS;
 
-    switch (enmDest)
-    {
-        case Source:
+    switch (enmView)
+    {
+        case View_Source:
             m_strSrcPath = strPath;
             break;
 
-        case Target:
+        case View_Target:
             m_strTgtPath = strPath;
             break;
@@ -155,9 +155,9 @@
         && fOpen) /* Opening mode specified? */
     {
-        LogFlowThisFunc(("enmType=%RU32, strPath=%s, fOpen=0x%x, enmType=%RU32, enmDest=%RU32\n",
-                         enmType, strPath.c_str(), fOpen, enmType, enmDest));
+        LogFlowThisFunc(("strPath=%s, enmType=%RU32, enmView=%RU32, fOpen=0x%x, fMode=0x%x, fFlags=0x%x\n",
+                         strPath.c_str(), enmType, enmView, fOpen, fFlags));
         switch (enmType)
         {
-            case File:
+            case Type_File:
             {
                 if (!m_fOpen)
@@ -207,5 +207,5 @@
             }
 
-            case Directory:
+            case Type_Directory:
                 rc = VINF_SUCCESS;
                 break;
@@ -294,7 +294,7 @@
     switch (m_Type)
     {
-        case File:
-        {
-            rc = OpenEx(m_strSrcPath, File, Source,
+        case Type_File:
+        {
+            rc = OpenEx(m_strSrcPath, Type_File, View_Source,
                         /* Use some sensible defaults. */
                         RTFILE_O_OPEN | RTFILE_O_READ | RTFILE_O_DENY_WRITE, 0 /* fFlags */);
@@ -319,5 +319,5 @@
         }
 
-        case Directory:
+        case Type_Directory:
         {
             rc = VINF_SUCCESS;
@@ -346,5 +346,5 @@
     Close();
 
-    m_Type        = Unknown;
+    m_Type        = Type_Unknown;
     m_strSrcPath  = "";
     m_strTgtPath  = "";
@@ -365,7 +365,7 @@
     switch (m_Type)
     {
-        case File:
-        {
-            rc = OpenEx(m_strTgtPath, File, Target,
+        case Type_File:
+        {
+            rc = OpenEx(m_strTgtPath, Type_File, View_Target,
                         /* Use some sensible defaults. */
                         RTFILE_O_OPEN_CREATE | RTFILE_O_DENY_WRITE | RTFILE_O_WRITE, 0 /* fFlags */);
@@ -379,5 +379,5 @@
         }
 
-        case Directory:
+        case Type_Directory:
         {
             rc = VINF_SUCCESS;