Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 74550)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 74551)
@@ -358,7 +358,4 @@
 	./src/runtime/information \
 	./src/runtime/guestctrl \
-	./src/selector \
-	./src/selector/graphics/chooser \
-	./src/selector/graphics/details \
 	./src/settings \
 	./src/settings/global \
@@ -376,6 +373,11 @@
 	./src/wizards/firstrun
 
-ifdef VBOX_GUI_WITH_NEW_MANAGER
-VBOX_GUI_INC_DIRS += \
+ifndef VBOX_GUI_WITH_NEW_MANAGER
+ VBOX_GUI_INC_DIRS += \
+	./src/selector \
+	./src/selector/graphics/chooser \
+	./src/selector/graphics/details
+else
+ VBOX_GUI_INC_DIRS += \
 	./src/manager \
 	./src/manager/chooser \
@@ -682,27 +684,4 @@
 	src/medium/UIMediumDetailsWidget.h \
 	src/medium/UIMediumManager.h \
-	src/selector/UIDesktopPane.h \
-	src/selector/UIVMItem.h \
-	src/selector/UISelectorWindow.h \
-	src/selector/UIToolsPaneGlobal.h \
-	src/selector/UIToolsPaneMachine.h \
-	src/selector/UIToolsToolbar.h \
-	src/selector/graphics/chooser/UIGChooser.h \
-	src/selector/graphics/chooser/UIGChooserModel.h \
-	src/selector/graphics/chooser/UIGChooserView.h \
-	src/selector/graphics/chooser/UIGChooserHandlerMouse.h \
-	src/selector/graphics/chooser/UIGChooserHandlerKeyboard.h \
-	src/selector/graphics/chooser/UIGChooserItem.h \
-	src/selector/graphics/chooser/UIGChooserItemGroup.h \
-	src/selector/graphics/chooser/UIGChooserItemMachine.h \
-	src/selector/graphics/details/UIGDetails.h \
-	src/selector/graphics/details/UIGDetailsModel.h \
-	src/selector/graphics/details/UIGDetailsView.h \
-	src/selector/graphics/details/UIGDetailsItem.h \
-	src/selector/graphics/details/UIGDetailsGroup.h \
-	src/selector/graphics/details/UIGDetailsSet.h \
-	src/selector/graphics/details/UIGDetailsElement.h \
-	src/selector/graphics/details/UIGDetailsElements.h \
-	src/selector/graphics/details/UIGMachinePreview.h \
 	src/snapshots/UISnapshotDetailsWidget.h \
 	src/snapshots/UISnapshotPane.h \
@@ -748,5 +727,30 @@
 	src/wizards/importappliance/UIWizardImportAppPageExpert.h
 
-ifdef VBOX_GUI_WITH_NEW_MANAGER
+ifndef VBOX_GUI_WITH_NEW_MANAGER
+ VirtualBox_QT_MOCHDRS += \
+	src/selector/UIDesktopPane.h \
+	src/selector/UIVMItem.h \
+	src/selector/UISelectorWindow.h \
+	src/selector/UIToolsPaneGlobal.h \
+	src/selector/UIToolsPaneMachine.h \
+	src/selector/UIToolsToolbar.h \
+	src/selector/graphics/chooser/UIGChooser.h \
+	src/selector/graphics/chooser/UIGChooserModel.h \
+	src/selector/graphics/chooser/UIGChooserView.h \
+	src/selector/graphics/chooser/UIGChooserHandlerMouse.h \
+	src/selector/graphics/chooser/UIGChooserHandlerKeyboard.h \
+	src/selector/graphics/chooser/UIGChooserItem.h \
+	src/selector/graphics/chooser/UIGChooserItemGroup.h \
+	src/selector/graphics/chooser/UIGChooserItemMachine.h \
+	src/selector/graphics/details/UIGDetails.h \
+	src/selector/graphics/details/UIGDetailsModel.h \
+	src/selector/graphics/details/UIGDetailsView.h \
+	src/selector/graphics/details/UIGDetailsItem.h \
+	src/selector/graphics/details/UIGDetailsGroup.h \
+	src/selector/graphics/details/UIGDetailsSet.h \
+	src/selector/graphics/details/UIGDetailsElement.h \
+	src/selector/graphics/details/UIGDetailsElements.h \
+	src/selector/graphics/details/UIGMachinePreview.h
+else
  VirtualBox_QT_MOCHDRS += \
 	src/manager/UIToolbarTools.h \
@@ -1210,5 +1214,4 @@
 #
 VirtualBox_QT_MOCSRCS = \
-	src/selector/UIDesktopPane.cpp \
 	src/snapshots/UISnapshotDetailsWidget.cpp \
 	src/snapshots/UISnapshotPane.cpp \
@@ -1217,5 +1220,8 @@
 	src/wizards/importappliance/UIWizardImportApp.cpp
 
-ifdef VBOX_GUI_WITH_NEW_MANAGER
+ifndef VBOX_GUI_WITH_NEW_MANAGER
+ VirtualBox_QT_MOCSRCS += \
+	src/selector/UIDesktopPane.cpp
+else
  VirtualBox_QT_MOCSRCS += \
 	src/manager/UIWelcomePane.cpp
@@ -1367,27 +1373,4 @@
 	src/medium/UIMediumDetailsWidget.cpp \
 	src/medium/UIMediumManager.cpp \
-	src/selector/UIDesktopPane.cpp \
-	src/selector/UIVMItem.cpp \
-	src/selector/UISelectorWindow.cpp \
-	src/selector/UIToolsPaneGlobal.cpp \
-	src/selector/UIToolsPaneMachine.cpp \
-	src/selector/UIToolsToolbar.cpp \
-	src/selector/graphics/chooser/UIGChooser.cpp \
-	src/selector/graphics/chooser/UIGChooserModel.cpp \
-	src/selector/graphics/chooser/UIGChooserView.cpp \
-	src/selector/graphics/chooser/UIGChooserHandlerMouse.cpp \
-	src/selector/graphics/chooser/UIGChooserHandlerKeyboard.cpp \
-	src/selector/graphics/chooser/UIGChooserItem.cpp \
-	src/selector/graphics/chooser/UIGChooserItemGroup.cpp \
-	src/selector/graphics/chooser/UIGChooserItemMachine.cpp \
-	src/selector/graphics/details/UIGDetails.cpp \
-	src/selector/graphics/details/UIGDetailsModel.cpp \
-	src/selector/graphics/details/UIGDetailsView.cpp \
-	src/selector/graphics/details/UIGDetailsItem.cpp \
-	src/selector/graphics/details/UIGDetailsGroup.cpp \
-	src/selector/graphics/details/UIGDetailsSet.cpp \
-	src/selector/graphics/details/UIGDetailsElement.cpp \
-	src/selector/graphics/details/UIGDetailsElements.cpp \
-	src/selector/graphics/details/UIGMachinePreview.cpp \
 	src/snapshots/UISnapshotDetailsWidget.cpp \
 	src/snapshots/UISnapshotPane.cpp \
@@ -1433,5 +1416,30 @@
 	src/wizards/importappliance/UIWizardImportAppPageExpert.cpp
 
-ifdef VBOX_GUI_WITH_NEW_MANAGER
+ifndef VBOX_GUI_WITH_NEW_MANAGER
+ VirtualBox_SOURCES += \
+	src/selector/UIDesktopPane.cpp \
+	src/selector/UIVMItem.cpp \
+	src/selector/UISelectorWindow.cpp \
+	src/selector/UIToolsPaneGlobal.cpp \
+	src/selector/UIToolsPaneMachine.cpp \
+	src/selector/UIToolsToolbar.cpp \
+	src/selector/graphics/chooser/UIGChooser.cpp \
+	src/selector/graphics/chooser/UIGChooserModel.cpp \
+	src/selector/graphics/chooser/UIGChooserView.cpp \
+	src/selector/graphics/chooser/UIGChooserHandlerMouse.cpp \
+	src/selector/graphics/chooser/UIGChooserHandlerKeyboard.cpp \
+	src/selector/graphics/chooser/UIGChooserItem.cpp \
+	src/selector/graphics/chooser/UIGChooserItemGroup.cpp \
+	src/selector/graphics/chooser/UIGChooserItemMachine.cpp \
+	src/selector/graphics/details/UIGDetails.cpp \
+	src/selector/graphics/details/UIGDetailsModel.cpp \
+	src/selector/graphics/details/UIGDetailsView.cpp \
+	src/selector/graphics/details/UIGDetailsItem.cpp \
+	src/selector/graphics/details/UIGDetailsGroup.cpp \
+	src/selector/graphics/details/UIGDetailsSet.cpp \
+	src/selector/graphics/details/UIGDetailsElement.cpp \
+	src/selector/graphics/details/UIGDetailsElements.cpp \
+	src/selector/graphics/details/UIGMachinePreview.cpp
+else
  VirtualBox_SOURCES += \
 	src/manager/UIToolbarTools.cpp \
@@ -2503,4 +2511,10 @@
 		extradata \
 		globals \
+		manager \
+		manager/chooser \
+		manager/details \
+		manager/tools \
+		manager \
+		manager \
 		medium \
 		net \